{% extends 'datacenter/base.html' %}
<!-- load crispy tags -->
{% load crispy_forms_tags %}
{% block content %}
  <div class="row col-xxl-6 col-xl-6 col-lg-8 col-md-10 m-auto p-0 mb-5">
    <div class="row bg-black border-bottom mt-3 mx-auto">
      <h1 class="text-white text-center">
        <a class="text-decoration-none text-white"
           href="{% url form_action pk=object.pk %}">{{ page_title }}</a>
      </h1>
    </div>
    <form action="{% url form_action pk=object.pk %}" method="post">
      <!-- add form errors displayed via crispy -->
      {{ form|as_crispy_errors:"bootstrap5" }}
      <!-- add crispy form helper and layout -->
      {% crispy form %}
      {% if form.instance and form.instance.get_used_units is not None %}
        <h5 class="mt-3">Devices in rack [used units: {{ form.instance.get_used_units }}]</h5>
        <div class="row mb-1 mx-auto text-center border-bottom">
          <div class="col-2 bg-dark text-white"></div>
          <div class="col-2 bg-dark text-white">Vertical size</div>
          <div class="col-2 bg-dark text-white">Device type</div>
          <div class="col-3 bg-dark text-white">Model Name</div>
          <div class="col-3 bg-dark text-white">In State</div>
        </div>
        {% for device in form.instance.devices_set.all %}
          {% if device.in_state not in device.not_displayed_states %}
            <div class="row align-items-center mx-auto text-center border-bottom py-1">
              <!-- link to device's detail -->
              <div class="col-2 btn btn-dark text-white">
                <a class="text-decoration-none text-white"
                   href="{{ device.get_absolute_url }}">Edit</a>
              </div>
              <div class="col-2 bg-light text-dark">{{ device.vertical_size }}</div>
              <!-- get full description for device_type field -->
              <div class="col-2 bg-light text-dark">{{ device.get_device_type_display }}</div>
              <div class="col-3 bg-light text-dark">{{ device.model_name }}</div>
              <!-- get full description for in_state field -->
              <div class="col-3 {% for state, color in device.in_state_colors_tags.items %}{% if state == device.in_state %}{{ color }}{% else %}{% endif %}{% endfor %} text-white py-2">
                {{ device.get_in_state_display }}
              </div>
            </div>
          {% else %}
          {% endif %}
        {% endfor %}
      {% else %}
        <h5 class="mt-3">
          {% if form.instance.pk %}
            No Devices in rack yet
          {% else %}
            Save rack in order to create device
          {% endif %}
        </h5>
      {% endif %}
      <hr>
      <div class="row col-12 bg-dark text-white mx-auto px-1 pt-2 pb-3 mt-2">
        <div class="col-xxl-4 col-xl-4 col-lg-4 col-md-6 col-sm-12 mx-auto p-0 px-1 mt-2">
          <input class="col-12 btn btn-dark text-white border border-white"
                 type="submit"
                 name="submit"
                 value="Save" />
        </div>
      </form>
      {% if form.instance.pk %}
        <div class="col-xxl-4 col-xl-4 col-lg-4 col-md-6 col-sm-12 p-0 px-1 mt-2 mx-auto">
          {% include 'datacenter/device-new-detail-modal.html' with pk_device=None pk_rack=form.instance.pk form_device=form_device  page_title="Add New Device" %}
        </div>
      {% else %}
      {% endif %}
    </div>
    <hr>
  </div>
{% endblock %}
